const _is                   = require("nv-validator-json-is");
    const {_un,_nu,_t,_f}   = _is;
const _pl                   = require("nv-validator-json-pl");
const _T                    = require("./t");

const _handle = (nd,j,k=_un)=> {
    nd[5] = k ;
    let is_c = _f
    if(_is.is_cls_or_func(j)) {
        nd[4] = j;
    } else if(_is.is_ary(j)) {
        nd.set_typ_to_ary();
        is_c = _t;
    } else if(_is.is_container(j)) {
        nd.set_typ_to_dict();
        is_c = _t;
    } else {
        nd[4] = j;
    }
    return(is_c)
}


class _Ele extends Array {
    constructor(rt,j) {
        super();
        this.push(rt);
        this.push(j);
    }
    get nd_()           {return(this[0])}
    get j_()            {return(this[1])} 
}

const _creat_ele = (nd,j) => new _Ele(nd,j);

const creat_from_j = (forest,Node,j) => {
    let rt   = forest.node(Node);
    let is_c = _handle(rt,j,_nu); 
    if(is_c) {
        let ele             = _creat_ele(rt,j);
        let unhandled      = [ele];
        let next_unhandled = [];
        while(unhandled.length>0) {
            for(let ele of unhandled) {
                let pnd = ele.nd_;
                let pj  = ele.j_;
                if(pnd.is_ary()) {
                    for(let i=0;i<pj.length;i++) {
                        let j  = pj[i];
                        let nd = pnd.$append_child();
                        let is_c = _handle(nd,j,_un);
                        if(is_c) {
                             next_unhandled.push(_creat_ele(nd,j))
                        } else {}
                    }
                } else if(pnd.is_dict()) {
                    for(let k in pj) {
                        let j  = pj[k];
                        let nd = pnd.$append_child();
                        let is_c = _handle(nd,j,k);
                        if(is_c) {
                              next_unhandled.push(_creat_ele(nd,j))
                        } else {}
                    }
                } else {
                }
            }
            unhandled = next_unhandled;
            next_unhandled =[];
        }
    } else {

    }
    return(rt)
}


const _rtize = (nd)=> {
    let lb   = nd.$lsib_;
    let pr   = nd.$parent_;
    let oldk = nd[5];
    nd.$disconn();
    nd[5]    = _nu;
    return([pr,lb,oldk])
}

const _recover = (nd,pr,lb,oldk) => {
    if(pr===_nu) {
    } else {
        if(lb===_nu) {
            pr.$prepend_child(nd)
        } else {
            lb.$add_rsib(nd)
        }
        nd[5] = oldk;
    }
}

const DFLT_LEAF_FUNC = (leaf)=>leaf.val_;

const __calc_and_keep_rslt_for_ary  = (self,children,rslt_key)  => {
     let rslt = [];
     for(let chnd of children) {
         rslt.push(chnd[rslt_key]);
     }
     return(rslt)
}
const __calc_and_keep_rslt_for_dict = (self,children,rslt_key) => {
     let rslt = {};
     for(let chnd of children) {
         rslt[chnd[5]] = chnd[rslt_key];
     }
     return(rslt)
}


const __calc_and_keep_rslt = (self,children,leaf_func,rslt_key) => {
      if(self.is_ary()) {
          return(__calc_and_keep_rslt_for_ary(self,children,rslt_key));
      } else if(self.is_dict()) {
          return(__calc_and_keep_rslt_for_dict(self,children,rslt_key));
      } else {
          return(leaf_func(self));
      }
}

const _calc_and_keep_rslt = (nd,leaf_func = DFLT_LEAF_FUNC) => {
    let [pr,lb,oldk] = _rtize(nd);
    nd.$bot2up_sync_calc(
         (self,children,rslt_key) => __calc_and_keep_rslt(self,children,leaf_func,rslt_key),
         6,
         _f
    );
    _recover(nd,pr,lb,oldk);
    return(nd[6])
}

const __calc_and_del_rslt_for_ary  = (self,children,rslt_key)  => {
     let rslt = [];
     for(let chnd of children) {
         rslt.push(chnd[rslt_key]);
         chnd[rslt_key] = _un;
     }
     return(rslt)
}
const __calc_and_del_rslt_for_dict = (self,children,rslt_key) => {
     let rslt = {};
     for(let chnd of children) {
         rslt[chnd[5]] = chnd[rslt_key];
         chnd[rslt_key] = _un;
     }
     return(rslt)
}

const __calc_and_del_rslt = (self,children,leaf_func,rslt_key) => {
      let r ;
      if(self.is_ary()) {
          r = __calc_and_del_rslt_for_ary(self,children,rslt_key);
      } else if(self.is_dict()) {
          r = __calc_and_del_rslt_for_dict(self,children,rslt_key);
      } else {
          r =leaf_func(self);
      }
      return(r)
}

const _calc_and_del_rslt = (nd,leaf_func = DFLT_LEAF_FUNC) => {
    let [pr,lb,oldk] = _rtize(nd);
    nd.$bot2up_sync_calc(
         (self,children,rslt_key) => __calc_and_del_rslt(self,children,leaf_func,rslt_key), 
         6,
         _f 
    );
    let _final = nd[6]; 
    nd[6] = _un;
    _recover(nd,pr,lb,oldk);
    return(_final) 
}
////

const DFLT_TREAT_NULL_AS_EMPTY_LEAF_FUNC = (leaf)=>_is.is_un(leaf.val_)?_nu:leaf.val_;

const __calc_treat_null_as_empty_for_ary  = (self,children,rslt_key)  => {
     if(_is.is_nu(self[4])) {
         return(_nu)
     } else {
         let rslt = [];
         for(let chnd of children) {
             let v = chnd[rslt_key];
             if(_is.is_nu(v)) {
             } else {
                  rslt.push(v);
             }
             chnd[rslt_key] = _un;
         }
         return(rslt)
     }
}
const __calc_treat_null_as_empty_for_dict = (self,children,rslt_key) => {
     if(_is.is_nu(self[4])) {
         return(_nu)
     } else {
         let rslt = {};
         for(let chnd of children) {
             let v = chnd[rslt_key];
             if(_is.is_nu(v)) {
             } else {
                 rslt[chnd[5]] = v;
             }
             chnd[rslt_key] = _un;
         }
         return(rslt)
     }
}

const __calc_treat_null_as_empty = (self,children,leaf_func,rslt_key) => {
      let r ;
      if(self.is_ary()) {
          r = __calc_treat_null_as_empty_for_ary(self,children,rslt_key);
      } else if(self.is_dict()) {
          r = __calc_treat_null_as_empty_for_dict(self,children,rslt_key);
      } else {
          r =leaf_func(self);
      }
      return(r)
}


const _calc_treat_null_as_empty_eng = (nd,leaf_func) => {
    let [pr,lb,oldk] = _rtize(nd);
    nd.$bot2up_sync_calc(
         (self,children,rslt_key) => __calc_treat_null_as_empty(self,children,leaf_func,rslt_key), 
         6,
         _f 
    );
    let _final = nd[6]; 
    nd[6] = _un;
    _recover(nd,pr,lb,oldk);
    return(_final) 
}

const _calc_treat_null_as_empty = (nd)=>_calc_treat_null_as_empty_eng(nd,DFLT_TREAT_NULL_AS_EMPTY_LEAF_FUNC);

const LIGHT_NVDBJ_LEAF_FUNC = (leaf)=> {
    let val = leaf.val_;
    if(_is.is_prim(val)) {
        
    } else if(_is.is_cls_or_func(val)) {
        val = val.toString();
    } else if(_is.is_bigint(val)) {
        val = String(val)
    } else if(_is.is_sym(val)) {
        val = val.description;
    }
    return(val)
}

const DFLT_TREAT_NULL_AS_EMPTY_LEAF_FUNC_FOR_LIGHT_NVDBJ = (leaf)=>_is.is_un(leaf.val_)?_nu:LIGHT_NVDBJ_LEAF_FUNC(leaf);

const _calc_treat_null_as_empty_for_light_nvdbj = (nd)=>_calc_treat_null_as_empty_eng(
    nd,DFLT_TREAT_NULL_AS_EMPTY_LEAF_FUNC_FOR_LIGHT_NVDBJ
);

module.exports = {
    DFLT_LEAF_FUNC,DFLT_TREAT_NULL_AS_EMPTY_LEAF_FUNC,
    LIGHT_NVDBJ_LEAF_FUNC,DFLT_TREAT_NULL_AS_EMPTY_LEAF_FUNC_FOR_LIGHT_NVDBJ,
    _rtize,_recover,
    __calc_and_keep_rslt_for_ary,
    __calc_and_keep_rslt_for_dict,
    __calc_and_keep_rslt,
    _calc_and_keep_rslt,
    __calc_and_del_rslt_for_ary,
    __calc_and_del_rslt_for_dict,
    __calc_and_del_rslt,
    _calc_and_del_rslt,
    __calc_treat_null_as_empty_for_ary,
    __calc_treat_null_as_empty_for_dict,
    __calc_treat_null_as_empty,
    _calc_treat_null_as_empty_eng,
    _calc_treat_null_as_empty,
    _calc_treat_null_as_empty_for_light_nvdbj,
    creat_from_j,
}



