const N2SEQ = {
    un:0, 
   nu:10,
   bool:20,
   t:21,
   f:22, 
   num:30, 
   int:31,
   float:32,
   str:40,
   ary:50,
   dict:60 
}


const SEQ2N = {
    "0" : "un",
    "10": "nu",
    "20": "bool",
    "21": "t",
    "22": "f",
    "30": "num",
    "31": "int",
    "32": "float",
    "40": "str",
    "50": "ary",
    "60": "dict"    
}


module.exports = {
   N2SEQ,
   SEQ2N,
   is_unset: (seq)=>seq === 0,
   is_ary  : (seq)=>seq === N2SEQ.ary,
   is_dict : (seq)=>seq === N2SEQ.dict,
   is_prim : (seq)=>seq>=10 && seq < 50 
}
